# -*- coding: utf-8 -*-
"""
Created on Mon Mar  7 21:34:34 2022

@author: kevin
"""


import qcodes as qc
from time import sleep, localtime
import numpy as np
import math
import datetime
import pandas as pd
import matplotlib.pyplot as plt
from scipy.signal  import savgol_filter, butter, filtfilt
from scipy import interpolate
from scipy.optimize import curve_fit
import scipy.constants as constants
import scipy
import numpy as np
import scipy.constants as constant
import scipy.integrate 
import matplotlib.pyplot as plt
import scipy.spatial.distance as scd
import scipy.misc as scm
import os

#Changes Working Directory to File Directory
abspath = os.path.abspath(__file__)
dname = os.path.dirname(abspath)
os.chdir(dname)

def parabolic(x,a,b,c):
    return a*x**2+b*x+c

def splitsweep(array):
    if len(array)%2 == 0:
        return array[:int(len(array)/2)], array[int(len(array)/2):]
    else:
        print('Array Length is odd !')
        
def splitsweep2(array):
    return array[:,:int(array.shape[1]/2)], array[:,int(array.shape[1]/2)]

def Niebler(Z):
    return 2*(1+2*Z**2) * np.arctanh(2*Z*np.sqrt((1+Z**2)/(1+6*Z**2+4*Z**4))) * (Z*np.sqrt((1+Z**2)*(1+6*Z**2+4*Z**4)))**-1-(4/3)
    


#qc.config["core"]["db_location"] = "C:/Users/kevin/Desktop/Transport/VTI_M13_563/2021_08_16/experimentsV3_5.db"
#qc.config["core"]["db_location"] = "C:/Users/kevin/Desktop/Transport/VTI_M13_563/2021_08_16/experimentsV2_23.db"
qc.config["core"]["db_location"] = "C:/Users/kevin/Desktop/Desktop Files 2/Transport/VTI_M13_563R/experimentsV4_5.db"


IDs = np.array([482,480,478,476,474,472,470,468,466,467,469,471,473,475,477,479,481])
AC_Conversion = 0.1
Lock_Amp = 0.1
T_Lock = 1.5
######################################################

X_lock = list()
B2 = list()
GainA = list()
I = list()
Rdiff = list()
Gdiff = list()
GateV = list()
I_sample = list()
U = list()
T2 = list()
TopgateV = list()
Phase = list()

Count = 0
for i in IDs:
    print(i)
    print(Count)
    qc_data_obj = qc.load_by_id(i)
    df = qc_data_obj.to_pandas_dataframe_dict()
    #time[Count] = np.array(df['time']['time'])
    X_lock.append(np.array(df['X_lock']['X_lock']))
    Phase.append(np.array(df['Phase_lock']['Phase_lock']))
    GateV.append(np.array(df['GateV']['GateV']))
    U.append(np.array(df['U']['U']))
    I.append(np.array(df['I']['I']))
    GainA.append(np.array(df['GainA']['GainA']))
    B2.append(np.array(df['B']['B']))
    T2.append(np.array(df['T']['T']))
    TopgateV.append(np.array(df['TopgateV']['TopgateV']))
    Rdiff.append(np.array(abs(X_lock[Count]/GainA[Count]/I[Count]/Lock_Amp/AC_Conversion)))
    Gdiff.append(1/(np.array(abs(X_lock[Count]/GainA[Count]/I[Count]/Lock_Amp/AC_Conversion))))
    Count+=1

I_sample = np.multiply(GateV,I)
U_sample = np.divide(U,GainA)  
IAC = Lock_Amp*AC_Conversion*I[0][0]
U_AC = np.divide(X_lock,GainA) 
Gcolor = np.array([-10,-8,-6,-5,-4,-3,-2,-1,0,1,2,3,4,5,6,8,10])
T_real = np.array([1.5])
dRgate0 = np.array([-319.31465422, -301.82515513, -287.26987294, -276.74850604, -241.82513053, -207.06161676, -174.90198395, -76.90010893, 0, 86.84388358, 190.2039455 , 277.54845997, 358.35826211, 382.18038753, 457.8229873 , 529.08812774, 585.70836196])
dRgate1 = np.array([-280.77962729, -276.20812375, -260.44382316, -239.32212973, -212.96541605, -197.0652584 , -161.3610572 ,  -74.04395434,0, 75.24506743, 164.78044027, 255.97967927, 325.70302738, 351.23311095, 388.69269402, 429.85620263, 477.90800665])
#%%
m = len(IDs)
for i in range (m):
    df = pd.DataFrame({"U_DC(V)" : U_sample[i], "I_DC(A)" : I_sample[i], "U_AC(V)" : U_AC[i], "I_AC(A)" : IAC, "Phase_U_AC(deg)" : Phase[i], "f_AC(Hz)" : 31.7, "T_integration_Lock(s)" : 1.5, "B(T)" : B2[i], "T(K)" : T_real[0], "Gatevoltage(V)" : TopgateV[i]})
    df.to_csv("Rawdata_Gate_" + str('%.0f'%(Gcolor[i])) + "V.csv", index=False)

#%% Plot dIdV T-Batch
plt.rcParams.update({'font.size': 42})
plt.rc('lines',linewidth=2,linestyle='-')
plt.rcParams['figure.figsize'] = (15,15)
plt.rcParams['xtick.direction'] = 'in'
plt.rcParams['ytick.direction'] = 'in'
plt.rcParams['xtick.top'] = 'True'
plt.rcParams['ytick.right'] = 'True'
plt.rcParams['axes.linewidth'] = '4'
plt.rcParams['xtick.major.size'] = '25'
plt.rcParams['xtick.major.width'] = '4'
plt.rcParams['ytick.major.size'] = '25'
plt.rcParams['ytick.major.width'] = '4'
plt.rcParams['xtick.major.pad'] = '15'
plt.rcParams['ytick.major.pad'] = '15'
#########################################
plt.rcParams['figure.figsize'] = (15,15)
n = 17
c_buffer = 1.15
cmap = plt.cm.gist_heat
G_colors = (Gcolor[:n]-Gcolor[0])/(c_buffer*Gcolor[n-1]-Gcolor[0])
colors=cmap(G_colors)

plt.rcParams['axes.prop_cycle'] = plt.cycler(color = colors)
sm = plt.cm.ScalarMappable(cmap = plt.cm.gist_heat, norm=plt.Normalize(vmin=Gcolor[0], vmax=c_buffer*Gcolor[n-1]))
for run in range(n):
#for run in [0,4,8,12,13,14,15,16,17,18,19,20]:
    print(run)
    #run = 9
    direction = 1
    Delta = 1.06
    RTI = 0
    R_diff = splitsweep(Rdiff[run])[direction]
    I_DC = splitsweep(I_sample[run]*1e3)[direction]
    U_DC = splitsweep(U_sample[run]*1e3)[direction]
    #########################################
    R_int = R_diff-RTI
    U_int = U_DC-RTI*I_DC
    
    #shift peak to 0
    shift =8
    R_int = R_int[shift:]
    U_int = U_int[:-shift]
    G_int_planck = 1/(R_int)/((1.602*10**-19)**2/(6.626*10**-34))
    
    plt.plot(U_int,G_int_planck+ 0*run,label = str(Gcolor[run])+'V')
    #plt.axvline(0,color ='black')
    #plt.axvline(Delta,color ='black')
    #plt.axvline(-Delta,color ='black')
    #plt.plot([],[],label = 'RTI = ' + str('%.1f'%RTI) + 'Ohm')
        
#plt.title(str(IDs[0]) + '-' + str(IDs[-1]) + '[' + str(direction) + '] ' + 'Water20 $\Omega$' + ' RTI=' + str(RTI) +'$\Omega$'+' Shift=' + str(shift))
plt.xlabel('$E$(meV)')
plt.ylabel('$\dfrac{dI}{dV}$($e^2/h$)')
#plt.xlim(-13,13)
#ax = plt.colorbar(sm)
#ax.set_label('Gate(V)',rotation=0)
plt.legend(fontsize=22)
#plt.savefig('Paper_Fig5_batch' + str(IDs[0]) + '-' + str(IDs[-1]) + '_' + str(direction) + '.png')
#plt.savefig('Paper_Fig5_batch' + str(IDs[0]) + '-' + str(IDs[-1]) + '_' + str(direction) + '.pdf')

#%% Plot dVdI Batch normed on peak maximum 
plt.rcParams.update({'font.size': 42})
plt.rc('lines',linewidth=2,linestyle='-')
plt.rcParams['figure.figsize'] = (15,15)
plt.rcParams['xtick.direction'] = 'in'
plt.rcParams['ytick.direction'] = 'in'
plt.rcParams['xtick.top'] = 'True'
plt.rcParams['ytick.right'] = 'True'
plt.rcParams['axes.linewidth'] = '4'
plt.rcParams['xtick.major.size'] = '25'
plt.rcParams['xtick.major.width'] = '4'
plt.rcParams['ytick.major.size'] = '25'
plt.rcParams['ytick.major.width'] = '4'
plt.rcParams['xtick.major.pad'] = '15'
plt.rcParams['ytick.major.pad'] = '15'
#########################################
plt.rcParams['figure.figsize'] = (15,15)
n = 17
c_buffer = 1.15
cmap = plt.cm.jet
G_colors = (Gcolor[:n]-Gcolor[0])/(c_buffer*Gcolor[n-1]-Gcolor[0])
colors=cmap(G_colors)

plt.rcParams['axes.prop_cycle'] = plt.cycler(color = colors)
sm = plt.cm.ScalarMappable(cmap = plt.cm.gist_heat, norm=plt.Normalize(vmin=Gcolor[0], vmax=c_buffer*Gcolor[n-1]))
for run in range(n):
#for run in [0,4,8,12,13,14,15,16,17,18,19,20]:
    print(run)
    #run = 9
    direction = 1
    Delta = 1.06
    RTI = 0
    R_diff = splitsweep(Rdiff[run])[direction]
    I_DC = splitsweep(I_sample[run]*1e3)[direction]
    U_DC = splitsweep(U_sample[run]*1e3)[direction]
    #########################################
    R_int = R_diff-RTI
    U_int = U_DC-RTI*I_DC
    
    #shift peak to 0
    shift =9
    R_int = R_int[shift:]
    U_int = U_int[:-shift]
    G_int_planck = 1/(R_int)/((1.602*10**-19)**2/(6.626*10**-34))
    
    plt.plot(U_int,(R_int-dRgate1[run])/1000+ 0*run,label = str(Gcolor[run])+'V')
    #plt.axvline(0,color ='black')
    #plt.axvline(Delta,color ='black')
    #plt.axvline(-Delta,color ='black')
    #plt.plot([],[],label = 'RTI = ' + str('%.1f'%RTI) + 'Ohm')
        
#plt.title(str(IDs[0]) + '-' + str(IDs[-1]) + '[' + str(direction) + '] ' + 'Water20 $\Omega$' + ' RTI=' + str(RTI) +'$\Omega$'+' Shift=' + str(shift))
plt.xlabel('$E$(meV)')
plt.ylabel('$\dfrac{dV}{dI}(k\Omega)$')
plt.xlim(-80,90)
#ax = plt.colorbar(sm)
#ax.set_label('Gate(V)',rotation=0)
plt.legend(fontsize=26)
#plt.savefig('Paper_Fig5_batch' + str(IDs[0]) + '-' + str(IDs[-1]) + '_' + str(direction) + '.png')
plt.savefig('Supp_Gate_peaknorm' + str(IDs[0]) + '-' + str(IDs[-1]) + '_' + str(direction) + '.pdf')

#%% Plot dIdV Batch normed on peak maximum 
plt.rcParams.update({'font.size': 42})
plt.rc('lines',linewidth=2,linestyle='-')
plt.rcParams['figure.figsize'] = (15,15)
plt.rcParams['xtick.direction'] = 'in'
plt.rcParams['ytick.direction'] = 'in'
plt.rcParams['xtick.top'] = 'True'
plt.rcParams['ytick.right'] = 'True'
plt.rcParams['axes.linewidth'] = '4'
plt.rcParams['xtick.major.size'] = '25'
plt.rcParams['xtick.major.width'] = '4'
plt.rcParams['ytick.major.size'] = '25'
plt.rcParams['ytick.major.width'] = '4'
plt.rcParams['xtick.major.pad'] = '15'
plt.rcParams['ytick.major.pad'] = '15'
#########################################
plt.rcParams['figure.figsize'] = (15,15)
n = 17
c_buffer = 1.15
cmap = plt.cm.jet
G_colors = (Gcolor[:n]-Gcolor[0])/(c_buffer*Gcolor[n-1]-Gcolor[0])
colors=cmap(G_colors)

plt.rcParams['axes.prop_cycle'] = plt.cycler(color = colors)
sm = plt.cm.ScalarMappable(cmap = plt.cm.gist_heat, norm=plt.Normalize(vmin=Gcolor[0], vmax=c_buffer*Gcolor[n-1]))
for run in range(n):
#for run in [0,4,8,12,13,14,15,16,17,18,19,20]:
    print(run)
    #run = 9
    direction = 1
    Delta = 1.06
    RTI = 0
    R_diff = splitsweep(Rdiff[run])[direction]
    I_DC = splitsweep(I_sample[run]*1e3)[direction]
    U_DC = splitsweep(U_sample[run]*1e3)[direction]
    #########################################
    R_int = R_diff-RTI
    U_int = U_DC-RTI*I_DC
    
    #shift peak to 0
    shift =9
    R_int = R_int[shift:]
    U_int = U_int[:-shift]
    G_int_planck = 1/(R_int-dRgate1[run])/((1.602*10**-19)**2/(6.626*10**-34))
    
    plt.plot(U_int,G_int_planck+ 0*run,label = str(Gcolor[run])+'V')
    #plt.axvline(0,color ='black')
    #plt.axvline(Delta,color ='black')
    #plt.axvline(-Delta,color ='black')
    #plt.plot([],[],label = 'RTI = ' + str('%.1f'%RTI) + 'Ohm')
        
#plt.title(str(IDs[0]) + '-' + str(IDs[-1]) + '[' + str(direction) + '] ' + 'Water20 $\Omega$' + ' RTI=' + str(RTI) +'$\Omega$'+' Shift=' + str(shift))
plt.xlabel('$E$(meV)')
plt.ylabel('$\dfrac{dI}{dV}(e^2/h)$')
plt.xlim(-80,90)
#ax = plt.colorbar(sm)
#ax.set_label('Gate(V)',rotation=0)
plt.legend(fontsize=26)
#plt.savefig('Paper_Fig5_batch' + str(IDs[0]) + '-' + str(IDs[-1]) + '_' + str(direction) + '.png')
plt.savefig('Supp_Gate_peaknormdIdV' + str(IDs[0]) + '-' + str(IDs[-1]) + '_' + str(direction) + '.pdf')
