# -*- coding: utf-8 -*-
"""
Created on Fri May  6 10:42:20 2022

@author: kevin
"""


# plot 563RB batch
# subtract RTI = 1220 Ohm as in fit up to 2T
# plot against U

import qcodes as qc
from time import sleep, localtime
import numpy as np
import math
import datetime
import pandas as pd
import matplotlib.pyplot as plt
from scipy.signal  import savgol_filter, butter, filtfilt
from scipy import interpolate
from scipy.optimize import curve_fit
import scipy.constants as constants
import scipy
import numpy as np
import scipy.constants as constant
import scipy.integrate 
import matplotlib.pyplot as plt
import scipy.spatial.distance as scd
import scipy.misc as scm
import os

#Changes Working Directory to File Directory
abspath = os.path.abspath(__file__)
dname = os.path.dirname(abspath)
os.chdir(dname)

def parabolic(x,a,b,c):
    return a*x**2+b*x+c

def splitsweep(array):
    if len(array)%2 == 0:
        return array[:int(len(array)/2)], array[int(len(array)/2):]
    else:
        print('Array Length is odd !')
        
def splitsweep2(array):
    return array[:,:int(array.shape[1]/2)], array[:,int(array.shape[1]/2):]

def Niebler(Z):
    return 2*(1+2*Z**2) * np.arctanh(2*Z*np.sqrt((1+Z**2)/(1+6*Z**2+4*Z**4))) * (Z*np.sqrt((1+Z**2)*(1+6*Z**2+4*Z**4)))**-1-(4/3)
    

plt.rcParams.update({'font.size': 42})
plt.rc('lines',linewidth=2,linestyle='-')
plt.rcParams['figure.figsize'] = (15,15)
plt.rcParams['xtick.direction'] = 'in'
plt.rcParams['ytick.direction'] = 'in'
plt.rcParams['xtick.top'] = 'True'
plt.rcParams['ytick.right'] = 'True'
plt.rcParams['axes.linewidth'] = '4'
plt.rcParams['xtick.major.size'] = '25'
plt.rcParams['xtick.major.width'] = '4'
plt.rcParams['ytick.major.size'] = '25'
plt.rcParams['ytick.major.width'] = '4'
plt.rcParams['xtick.major.pad'] = '15'
plt.rcParams['ytick.major.pad'] = '15'
#qc.config["core"]["db_location"] = "C:/Users/kevin/Desktop/Transport/VTI_M13_563/2021_08_16/experimentsV3_5.db"
#qc.config["core"]["db_location"] = "C:/Users/kevin/Desktop/Transport/VTI_M13_563/2021_08_16/experimentsV2_23.db"
qc.config["core"]["db_location"] = "C:/Users/kevin/Desktop/Desktop Files 2/Transport/VTI_M13_563R/experimentsV4_5.db"

id1 = 437
id2 = 457
#id1 = 59
#id2 = 76
IDs = np.linspace(id1,id2,id2-id1+1).astype(int)

AC_Conversion = 0.1
Lock_Amp = 0.1
T_Lock = 1.5
######################################################

X_lock = list()
B2 = list()
GainA = list()
I = list()
Rdiff = list()
Gdiff = list()
GateV = list()
I_sample = list()
U = list()
T = list()
Phase = list()
#TopgateV = list()

Count = 0
for i in IDs:
    print(i)
    print(Count)
    qc_data_obj = qc.load_by_id(i)
    df = qc_data_obj.to_pandas_dataframe_dict()
    #time[Count] = np.array(df['time']['time'])
    X_lock.append(np.array(df['X_lock']['X_lock']))
    Phase.append(np.array(df['Phase_lock']['Phase_lock']))
    GateV.append(np.array(df['GateV']['GateV']))
    U.append(np.array(df['U']['U']))
    I.append(np.array(df['I']['I']))
    GainA.append(np.array(df['GainA']['GainA']))
    B2.append(np.array(df['B']['B']))
    T.append(np.array(df['T']['T']))
    #TopgateV.append(np.array(df['TopgateV']['TopgateV']))
    Rdiff.append(np.array(abs(X_lock[Count]/GainA[Count]/I[Count]/Lock_Amp/AC_Conversion)))
    Gdiff.append(1/(np.array(abs(X_lock[Count]/GainA[Count]/I[Count]/Lock_Amp/AC_Conversion))))
    Count+=1

I_sample = np.multiply(GateV,I)
U_sample = np.divide(U,GainA)  
IAC = Lock_Amp*AC_Conversion*I[0][0]
U_AC = np.divide(X_lock,GainA) 
Bcolor = np.array([0,0.2,0.4,0.6,0.8,1,1.2,1.4,1.6,1.8,2,2.2,2.4,2.6,2.8,3,3.2,3.6,4,5,6])
T_real = np.array([1.5])
#%%
m = len(IDs)
for i in range (m):
    df = pd.DataFrame({"U_DC(V)" : U_sample[i], "I_DC(A)" : I_sample[i], "U_AC(V)" : U_AC[i], "I_AC(A)" : IAC, "Phase_U_AC(deg)" : Phase[i], "f_AC(Hz)" : 31.7, "T_integration_Lock(s)" : 1.5, "B(T)" : B2[i], "T(K)" : T_real[0]})
    df.to_csv("Rawdata_B_" + str('%.0f'%(B2[i][0]*1000)) + "mT.csv", index=False)

#%% Plot dIdV B-Batch SC 
plt.rcParams.update({'font.size': 42})
plt.rc('lines',linewidth=2,linestyle='-')
plt.rcParams['figure.figsize'] = (15,15)
plt.rcParams['xtick.direction'] = 'in'
plt.rcParams['ytick.direction'] = 'in'
plt.rcParams['xtick.top'] = 'True'
plt.rcParams['ytick.right'] = 'True'
plt.rcParams['axes.linewidth'] = '4'
plt.rcParams['xtick.major.size'] = '25'
plt.rcParams['xtick.major.width'] = '4'
plt.rcParams['ytick.major.size'] = '25'
plt.rcParams['ytick.major.width'] = '4'
plt.rcParams['xtick.major.pad'] = '15'
plt.rcParams['ytick.major.pad'] = '15'
#########################################
plt.rcParams['figure.figsize'] = (15,7.5)
n = 12 #12
c_buffer = 1.15
cmap = plt.cm.gist_heat
B_colors = (Bcolor[:n]-Bcolor[0])/(c_buffer*Bcolor[n-1]-Bcolor[0])
colors=cmap(B_colors)
#colors=plt.cm.gist_heat(Bcolor[0:n]*6/(Bcolor[n]*6))
plt.rcParams['axes.prop_cycle'] = plt.cycler(color = colors) 
for run in range(n):
    
    #run = 9
    direction = 1
    Delta = 1.06
    RTI = 1220
    R_diff = splitsweep(Rdiff[run])[direction]
    I_DC = splitsweep(I_sample[run]*1e3)[direction]
    U_DC = splitsweep(U_sample[run]*1e3)[direction]
    #########################################
    R_int = R_diff-RTI
    U_int = U_DC-RTI*I_DC
    
    #shift peak to 0
    shift =8
    R_int = R_int[shift:]
    U_int = U_int[:-shift]
    
    G_int_planck = 1/(R_int)/((1.602*10**-19)**2/(6.626*10**-34))
    #colors=plt.cm.gist_heat(np.linspace(0,1,n))
    #plt.rcParams['axes.prop_cycle'] = plt.cycler(color = colors)
    
    plt.plot(U_int,G_int_planck+ -6*run,label = 'B='+str('%.2f'%B2[run][0])+'T')
    plt.axvline(0,color ='black')
    #plt.axvline(Delta,color ='black')
    #plt.axvline(-Delta,color ='black')
    #plt.plot([],[],label = 'RTI = ' + str('%.1f'%RTI) + 'Ohm')
    
     
#plt.title(str(IDs[0]) + '-' + str(IDs[-1]) + '[' + str(direction) + '] ' + 'Water20 $\Omega$' + ' RTI=' + str(RTI) +'$\Omega$'+' Shift=' + str(shift))
plt.xlabel('$E$(meV)')
plt.ylabel('$\dfrac{dI}{dV}$($e^2/h$)')
plt.xlim(-13,13)
plt.ylim(-20,140)
#sm = plt.cm.ScalarMappable(cmap = plt.cm.gist_heat, norm=plt.Normalize(vmin=Bcolor[0], vmax=c_buffer*Bcolor[n-1]))
#ax = plt.colorbar(sm)
#ax.set_label('B(T)',rotation=0)
#plt.legend(fontsize=22)
#plt.savefig('Paper_Fig3_' + str(IDs[0]) + '-' + str(IDs[-1]) + '_' + str(direction) + '.png')
#plt.savefig('Paper_Fig3_' + str(IDs[0]) + '-' + str(IDs[-1]) + '_' + str(direction) + '.pdf')

#%% Plot dIdV B-Batch out of SC 
#########################################
plt.rcParams['figure.figsize'] = (15,15)
n = 21
c_buffer = 1.15
cmap = plt.cm.gist_heat
B_colors = (Bcolor[:n]-Bcolor[0])/(c_buffer*Bcolor[n-1]-Bcolor[0])
colors=cmap(B_colors)

plt.rcParams['axes.prop_cycle'] = plt.cycler(color = colors)
sm = plt.cm.ScalarMappable(cmap = plt.cm.gist_heat, norm=plt.Normalize(vmin=Bcolor[0], vmax=c_buffer*Bcolor[n-1]))
for run in range(n):
#for run in [0,4,8,12,13,14,15,16,17,18,19,20]:
    print(run)
    #run = 9
    direction = 1
    Delta = 1.06
    RTI = 1220
    R_diff = splitsweep(Rdiff[run])[direction]
    I_DC = splitsweep(I_sample[run]*1e3)[direction]
    U_DC = splitsweep(U_sample[run]*1e3)[direction]
    #########################################
    R_int = R_diff-RTI
    U_int = U_DC-RTI*I_DC
    
    #shift peak to 0
    shift =8
    R_int = R_int[shift:]
    U_int = U_int[:-shift]
    G_int_planck = 1/(R_int)/((1.602*10**-19)**2/(6.626*10**-34))
    
    plt.plot(U_int,G_int_planck+ 0*run,label = 'B='+str('%.2f'%B2[run][0])+'T')
    #plt.axvline(0,color ='black')
    #plt.axvline(Delta,color ='black')
    #plt.axvline(-Delta,color ='black')
    #plt.plot([],[],label = 'RTI = ' + str('%.1f'%RTI) + 'Ohm')
        
#plt.title(str(IDs[0]) + '-' + str(IDs[-1]) + '[' + str(direction) + '] ' + 'Water20 $\Omega$' + ' RTI=' + str(RTI) +'$\Omega$'+' Shift=' + str(shift))
plt.xlabel('$E$(meV)')
plt.ylabel('$\dfrac{dI}{dV}$($e^2/h$)')
plt.xlim(-13,13)
ax = plt.colorbar(sm)
ax.set_label('B(T)',rotation=0)
#plt.legend(fontsize=22)
plt.savefig('Paper_Fig3_all' + str(IDs[0]) + '-' + str(IDs[-1]) + '_' + str(direction) + '.png')
plt.savefig('Paper_Fig3_all' + str(IDs[0]) + '-' + str(IDs[-1]) + '_' + str(direction) + '.pdf')
#%% Colormap B
direction = 1
e = 20 
c = 1
d = 600
R_diff = splitsweep2(np.array(Rdiff))[direction]
I_DC = splitsweep2(I_sample*1e3)[direction]
U_DC = splitsweep2(U_sample*1e3)[direction]
RTI = np.zeros((e,d))
R_int = np.zeros((e,d))
U_int = np.zeros((e,d))

run = 16

Delta = 1.06

for l in range(e):
    
    if direction == 0:
        RTI[l] = 1220
        R_int[l] = R_diff[l]-RTI[l]
        U_int[l] = U_DC[l]-RTI[l]*I_DC[l]
        print('direction 0')
    else:
        RTI[l] = 1220
        R_int[l] = R_diff[l]-RTI[l]
        U_int[l] = U_DC[l]-RTI[l]*I_DC[l]
        print('direction 1')
            

#shift peak to 0
shift =8
R_int = R_int[:,shift:]
U_int = U_int[:,:-shift]


fig = plt.figure()
ax = fig.add_subplot()
ax.set_facecolor('black')
for c in range(1,e+1):
    Bvalues = np.linspace(c-1-8,c-8,2)
    #Bvalues = np.array([0,0.2,0.4,0.6,0.8,1,1.2,1.4,1.6,1.8,2,2.2,2.4,2.6,2.8,3,3.2,3.6,4,5,6])
    a = np.array(Bvalues)  
    b = np.linspace(5, 0, d-shift)  
    xa, xb = np.meshgrid(a, b)
    Angles = xa.T
    plt.pcolormesh(U_int[c-1:c],Angles[0:2],R_int[c-1:c], cmap='jet', vmin = 200,vmax = 680, snap = True)
    
plt.colorbar(label = '$R_{Int} (\Omega)$')
#plt.yticks([-7.5,-6.5,-5.5,-3.5,-1.5,0.5,2.5,4.5,6.5,7.5,8.5],[-10,-8,-6,-4,-2,0,2,4,6,8,10])
#plt.xlim(-9,9)
plt.title(str(min(IDs)) + '-' + str(max(IDs))+ '[' + str(direction) + ']' + ' shift=' + str(shift))
plt.xlabel('$U_{Int} (mV)$')
plt.ylabel('$B$(T)')
#plt.savefig('Fig5_Gatemapcut_' + str(min(IDs)) + '-' + str(max(IDs))+ '_' + str(direction)+'.png')
#plt.savefig('Fig5_Gatemapcut_' + str(min(IDs)) + '-' + str(max(IDs))+ '_' + str(direction)+'.pdf')


#%% Peak Position Dependence [1]
plt.rcParams['figure.figsize'] = (15,7.5)
PeakL = np.array([-3.39,-3.33,-2.32,-2.03,-1.91,-1.97,-1.85,-1.70,-1.55,-1.32,-1.22,-1.08])
PeakR = np.array([3.03,3.02,2.95,2.48,2.27,1.80,1.60,1.43,1.31,1.13,1.01,0.89])
PeakB = np.array([0,0.2,0.4,0.6,0.8,1,1.2,1.4,1.6,1.8,2,2.2])

Peak = (PeakR-PeakL)/2
plt.scatter(PeakB, Peak, s=110)

def Linfunc(x,a,b):
    return a*x + b

popt2, pcov2 = curve_fit(Linfunc,PeakB[3:], Peak[3:])
plt.plot(PeakB, Linfunc(PeakB,popt2[0],popt2[1]),'-r', linewidth=3, label= '$E_{Dip}$= = ' + str('%.2f'%popt2[0]) + '$\cdot$B+' + str('%.2f'%popt2[1]) )
plt.title('ID:' + str(IDs[0]) + '-' + str(IDs[-1]) + ' RTI =' + str(RTI) +'$\Omega$')
plt.xlabel('$B$(T)')
plt.ylabel('$E_{Dip}$($meV$)')
plt.legend()
plt.savefig('Paper_Fig3_Fit_' + str(IDs[0]) + '-' + str(IDs[-1]) + '.png')
plt.savefig('Paper_Fig3_Fit_' + str(IDs[0]) + '-' + str(IDs[-1]) + '.pdf')
#plt.savefig(str(IDs[0]) + '-' + str(IDs[-1])+ 'PeakB'+'.png')