# -*- coding: utf-8 -*-
"""
Created on Mon Sep 27 09:47:13 2021

@author: kevin
"""


import qcodes as qc
from time import sleep, localtime
import numpy as np
import math
import datetime
import pandas as pd
import matplotlib.pyplot as plt
from scipy.signal import savgol_filter
from scipy import interpolate
from scipy.optimize import curve_fit
import os

#Changes Working Directory to File Directory
abspath = os.path.abspath(__file__)
dname = os.path.dirname(abspath)
os.chdir(dname)

def splitsweep(array):
    if len(array)%2 == 0:
        return array[:int(len(array)/2)], array[int(len(array)/2):]
    else:
        print('Array Length is odd !')
        
def splitsweep2(array):
    return array[:,:int(array.shape[1]/2)], array[:,int(array.shape[1]/2)]
    

plt.rcParams.update({'font.size': 32})
plt.rc('lines',linewidth=1.5,linestyle='-')
plt.rcParams['figure.figsize'] = (15,15)
plt.rcParams['xtick.direction'] = 'in'
plt.rcParams['ytick.direction'] = 'in'
plt.rcParams['xtick.top'] = 'True'
plt.rcParams['ytick.right'] = 'True'
plt.rcParams['axes.linewidth'] = '3'
plt.rcParams['xtick.major.size'] = '15'
plt.rcParams['xtick.major.width'] = '3'
plt.rcParams['ytick.major.size'] = '15'
plt.rcParams['ytick.major.width'] = '3'
plt.rcParams['xtick.major.pad'] = '15'
plt.rcParams['ytick.major.pad'] = '15'
#qc.config["core"]["db_location"] = "C:/Users/kevin/Desktop/Desktop Files 2/Transport/VTI_M13_563R/experimentsV4_5.db"
qc.config["core"]["db_location"] = "C:/Users/kevin/Desktop/Desktop Files 2/Transport/VTI_M13_563/2021_08_16/experimentsV3_5.db"
#qc.config["core"]["db_location"] = "C:/Users/kevin/Desktop/Desktop Files 2/Transport/VTI_M13_563/2021_08_16/experimentsV2_23.db"
######################################################

#id1 = 
#id2 = 542
#IDs = np.linspace(id1,id2,id2-id1+1).astype(int)

IDs = np.array([1,2])                      #Hallsweep 563L 12_52_1 in DB V3
#IDs = np.array([433,434])                  #Hallsweep 563L 11_14_1 in DB V2


AC_Conversion = 0.1
Lock_Amp = 0.1
T_Lock = 1.5
######################################################

X_lock = list()
B = list()
GainA = list()
I = list()
Rdiff = list()
GateV = list()
I_sample = list()
U = list()
T = list()
TopgateV = list()
Phase = list()

Count = 0
for i in IDs:
    print(i)
    print(Count)
    qc_data_obj = qc.load_by_id(i)
    df = qc_data_obj.to_pandas_dataframe_dict()
    #time[Count] = np.array(df['time']['time'])
    X_lock.append(np.array(df['X_lock']['X_lock']))
    Phase.append(np.array(df['Phase_lock']['Phase_lock']))
    GateV.append(np.array(df['GateV']['GateV']))
    U.append(np.array(df['U']['U']))
    I.append(np.array(df['I']['I']))
    GainA.append(np.array(df['GainA']['GainA']))
    B.append(np.array(df['B']['B']))
    T.append(np.array(df['T']['T']))
    #TopgateV.append(np.array(df['TopgateV']['TopgateV']))
    Rdiff.append(np.array(abs(X_lock[Count]/GainA[Count]/I[Count]/Lock_Amp/AC_Conversion)))
    Count+=1

I_sample = np.multiply(GateV,I)
U_sample = np.divide(U,GainA)  
IAC = Lock_Amp*AC_Conversion*I[0][0]
U_AC = np.divide(X_lock,GainA) 
T_real = np.array([1.5,1.6,2.2,2.6,3.3,4.8,6.5,9.9])

#%%
m = len(IDs)
for i in range (m):
    df = pd.DataFrame({"U_AC(V)" : U_AC[i], "I_AC(A)" : IAC, "Phase_U_AC(deg)" : Phase[i], "f_AC(Hz)" : 31.7, "T_integration_Lock(s)" : 1.5, "B(T)" : B[i],"T(K)" : T_real[0]})
    df.to_csv("Rawdata_Hall_" + str('%.0f'%i) + ".csv", index=False)
    
#%% Plot DiffHall for ID 1,2 in DB V3 
def Hallfunc(x,a,b):
    return a*x + b

run = 0 

Ix = 100*10**-9
d = 20*10**-9 #thickness
popt, pcov = curve_fit(Hallfunc,B[run], X_lock[run]/GainA[run][0]*1000000)
popt1, pcov1 = curve_fit(Hallfunc,B[run+1], X_lock[run+1]/GainA[run][0]*1000000)
n2D = Ix/(1.602*10**-19*popt[0]*10**-6)/10**4      # last factor conversion to cm-2
n3D = Ix/(1.602*10**-19*popt[0]*10**-6)/d/10**6    # last factor conversion to cm-3
n2D1 = Ix/(1.602*10**-19*popt1[0]*10**-6)/10**4      # last factor conversion to cm-2
n3D1 = Ix/(1.602*10**-19*popt1[0]*10**-6)/d/10**6    # last factor conversion to cm-3
n2Dmean = Ix/(1.602*10**-19*0.5*(popt[0]+popt1[0])*10**-6)/10**4      # last factor conversion to cm-2
n3Dmean = Ix/(1.602*10**-19*0.5*(popt[0]+popt1[0])*10**-6)/d/10**6    # last factor conversion to cm-3

#plt.plot(B[run], Hallfunc(B[run],popt[0],popt[1]),'-k', linewidth=4, label = 'U = ' + str('%.2f'%(popt[0])) +'$\, \mu V / T \cdot$ B'+ '+' + str('%.2f'%(popt[1])) + '$\, \mu V$' )
#plt.plot(B[run+1], Hallfunc(B[run+1],popt1[0],popt1[1]),'-k', linewidth=4, label = 'U = ' + str('%.2f'%(popt1[0])) +'$\, \mu V / T \cdot$ B'+ '+' + str('%.2f'%(popt1[1])) + '$\, \mu V$' )
plt.plot(B[run], Hallfunc(B[run],0.5*(popt[0]+popt1[0]),0.5*(popt[1]+popt1[1])),'-k', linewidth=4, label = 'U = ' + str('%.2f'%(0.5*(popt[0]+popt1[0]))) +'$\, \mu V / T \cdot$ B'+ '+' + str('%.2f'%(0.5*(popt[1]+popt1[1]))) + '$\, \mu V$' )
plt.plot(B[run],X_lock[run]/GainA[run][0]*1000000,'-b', linewidth=3, label = '$\\rightarrow$')
plt.plot(B[run+1],X_lock[run+1]/GainA[run+1][0]*1000000,'-r',linewidth=3, label = '$\\leftarrow$')
plt.title('ID:' + str(IDs[run]) +'| Hall | IAC = 100nA, T = 3s')
plt.xlabel('$B$ (T)')
plt.ylabel('$U_{Hall}$($\mu V$)')
plt.legend()

plt.savefig('Supp_Hall_DB_V3_' + str(IDs[0]) + '_' + '.png')
plt.savefig('Supp_Hall_DB_V3_' + str(IDs[0]) + '_' + '.pdf')
print('Supp_Hall_' + str(IDs[0]) + '.pdf' '  saved')
print ('n2D0= ' + str(f"{n2D:.2e}") +' cm^-2')
print ('n3D0= ' + str(f"{n3D:.2e}") +' cm^-3')
print ('n2D1= ' + str(f"{n2D1:.2e}") +' cm^-2')
print ('n3D1= ' + str(f"{n3D1:.2e}") +' cm^-3')
print ('n2Dmean= ' + str(f"{n2Dmean:.2e}") +' cm^-2')
print ('n3Dmean= ' + str(f"{n3Dmean:.2e}") +' cm^-3')

#%% Plot DiffHall for ID 433,434 in DB V2 
def Hallfunc(x,a,b):
    return a*x + b

run = 0 

Ix = 100*10**-9
d = 20*10**-9 #thickness
popt, pcov = curve_fit(Hallfunc,B[run], X_lock[run]/GainA[run][0]*1000000)
popt1, pcov1 = curve_fit(Hallfunc,B[run+1], X_lock[run+1]/GainA[run][0]*1000000)
n2D = Ix/(1.602*10**-19*popt[0]*10**-6)/10**4      # last factor conversion to cm-2
n3D = Ix/(1.602*10**-19*popt[0]*10**-6)/d/10**6    # last factor conversion to cm-3
n2D1 = Ix/(1.602*10**-19*popt1[0]*10**-6)/10**4      # last factor conversion to cm-2
n3D1 = Ix/(1.602*10**-19*popt1[0]*10**-6)/d/10**6    # last factor conversion to cm-3
n2Dmean = Ix/(1.602*10**-19*0.5*(popt[0]+popt1[0])*10**-6)/10**4      # last factor conversion to cm-2
n3Dmean = Ix/(1.602*10**-19*0.5*(popt[0]+popt1[0])*10**-6)/d/10**6    # last factor conversion to cm-3

#plt.plot(B[run], Hallfunc(B[run],popt[0],popt[1]),'-k', linewidth=4, label = 'U = ' + str('%.2f'%(popt[0])) +'$\, \mu V / T \cdot$ B'+ '+' + str('%.2f'%(popt[1])) + '$\, \mu V$' )
#plt.plot(B[run+1], Hallfunc(B[run+1],popt1[0],popt1[1]),'-k', linewidth=4, label = 'U = ' + str('%.2f'%(popt1[0])) +'$\, \mu V / T \cdot$ B'+ '+' + str('%.2f'%(popt1[1])) + '$\, \mu V$' )
plt.plot(B[run], Hallfunc(B[run],0.5*(popt[0]+popt1[0]),0.5*(popt[1]+popt1[1])),'-k', linewidth=4, label = 'U = ' + str('%.2f'%(0.5*(popt[0]+popt1[0]))) +'$\, \mu V / T \cdot$ B'+ '+' + str('%.2f'%(0.5*(popt[1]+popt1[1]))) + '$\, \mu V$' )
plt.plot(B[run],X_lock[run]/GainA[run][0]*1000000,'-b', linewidth=3, label = '$\\rightarrow$')
plt.plot(B[run+1],X_lock[run+1]/GainA[run+1][0]*1000000,'-r',linewidth=3, label = '$\\leftarrow$')
plt.title('ID:' + str(IDs[run]) +'| Hall | IAC = 100nA, T = 3s')
plt.xlabel('$B$ (T)')
plt.ylabel('$U_{Hall}$($\mu V$)')
plt.legend()

plt.savefig('Supp_Hall_DB_V2_' + str(IDs[0]) + '_' + '.png')
plt.savefig('Supp_Hall_DB_V2_' + str(IDs[0]) + '_' + '.pdf')
print('Supp_Hall_' + str(IDs[0]) + '.pdf' '  saved')
print ('n2D0= ' + str(f"{n2D:.2e}") +' cm^-2')
print ('n3D0= ' + str(f"{n3D:.2e}") +' cm^-3')
print ('n2D1= ' + str(f"{n2D1:.2e}") +' cm^-2')
print ('n3D1= ' + str(f"{n3D1:.2e}") +' cm^-3')
print ('n2Dmean= ' + str(f"{n2Dmean:.2e}") +' cm^-2')
print ('n3Dmean= ' + str(f"{n3Dmean:.2e}") +' cm^-3')







