# -*- coding: utf-8 -*-
"""
Created on Fri May  6 10:42:20 2022

@author: kevin
"""


# plot 563RB batch
# subtract RTI = 1220 Ohm as in fit up to 2T
# plot against U

import qcodes as qc
from time import sleep, localtime
import numpy as np
import math
import datetime
import pandas as pd
import matplotlib.pyplot as plt
from scipy.signal  import savgol_filter, butter, filtfilt
from scipy import interpolate
from scipy.optimize import curve_fit
import scipy.constants as constants
import scipy
import numpy as np
import scipy.constants as constant
import scipy.integrate 
import matplotlib.pyplot as plt
import scipy.spatial.distance as scd
import scipy.misc as scm
import os

#Changes Working Directory to File Directory
abspath = os.path.abspath(__file__)
dname = os.path.dirname(abspath)
os.chdir(dname)

def parabolic(x,a,b,c):
    return a*x**2+b*x+c

def splitsweep(array):
    if len(array)%2 == 0:
        return array[:int(len(array)/2)], array[int(len(array)/2):]
    else:
        print('Array Length is odd !')
        
def splitsweep2(array):
    return array[:,:int(array.shape[1]/2)], array[:,int(array.shape[1]/2)]

def Niebler(Z):
    return 2*(1+2*Z**2) * np.arctanh(2*Z*np.sqrt((1+Z**2)/(1+6*Z**2+4*Z**4))) * (Z*np.sqrt((1+Z**2)*(1+6*Z**2+4*Z**4)))**-1-(4/3)
    

plt.rcParams.update({'font.size': 42})
plt.rc('lines',linewidth=2,linestyle='-')
plt.rcParams['figure.figsize'] = (15,15)
plt.rcParams['xtick.direction'] = 'in'
plt.rcParams['ytick.direction'] = 'in'
plt.rcParams['xtick.top'] = 'True'
plt.rcParams['ytick.right'] = 'True'
plt.rcParams['axes.linewidth'] = '4'
plt.rcParams['xtick.major.size'] = '25'
plt.rcParams['xtick.major.width'] = '4'
plt.rcParams['ytick.major.size'] = '25'
plt.rcParams['ytick.major.width'] = '4'
plt.rcParams['xtick.major.pad'] = '15'
plt.rcParams['ytick.major.pad'] = '15'
#qc.config["core"]["db_location"] = "C:/Users/kevin/Desktop/Transport/VTI_M13_563/2021_08_16/experimentsV3_5.db"
#qc.config["core"]["db_location"] = "C:/Users/kevin/Desktop/Transport/VTI_M13_563/2021_08_16/experimentsV2_23.db"
qc.config["core"]["db_location"] = "C:/Users/kevin/Desktop/Desktop Files 2/Transport/VTI_M13_563R/experimentsV4_5.db"

id1 = 458
id2 = 465
#id1 = 59
#id2 = 76
IDs = np.linspace(id1,id2,id2-id1+1).astype(int)

AC_Conversion = 0.1
Lock_Amp = 0.1
T_Lock = 1.5
######################################################

X_lock = list()
B2 = list()
GainA = list()
I = list()
Rdiff = list()
Gdiff = list()
GateV = list()
I_sample = list()
U = list()
T = list()
Phase = list()
#TopgateV = list()

Count = 0
for i in IDs:
    print(i)
    print(Count)
    qc_data_obj = qc.load_by_id(i)
    df = qc_data_obj.to_pandas_dataframe_dict()
    #time[Count] = np.array(df['time']['time'])
    X_lock.append(np.array(df['X_lock']['X_lock']))
    Phase.append(np.array(df['Phase_lock']['Phase_lock']))
    GateV.append(np.array(df['GateV']['GateV']))
    U.append(np.array(df['U']['U']))
    I.append(np.array(df['I']['I']))
    GainA.append(np.array(df['GainA']['GainA']))
    B2.append(np.array(df['B']['B']))
    T.append(np.array(df['T']['T']))
    #TopgateV.append(np.array(df['TopgateV']['TopgateV']))
    Rdiff.append(np.array(abs(X_lock[Count]/GainA[Count]/I[Count]/Lock_Amp/AC_Conversion)))
    Gdiff.append(1/(np.array(abs(X_lock[Count]/GainA[Count]/I[Count]/Lock_Amp/AC_Conversion))))
    Count+=1

I_sample = np.multiply(GateV,I)
U_sample = np.divide(U,GainA)  
IAC = Lock_Amp*AC_Conversion*I[0][0]
U_AC = np.divide(X_lock,GainA) 
T_real = np.array([1.5,1.6,2.2,2.6,3.3,4.8,6.5,9.9])

#%%
m = len(IDs)
for i in range (m):
    df = pd.DataFrame({"U_DC(V)" : U_sample[i], "I_DC(A)" : I_sample[i], "U_AC(V)" : U_AC[i], "I_AC(A)" : IAC, "Phase_U_AC(deg)" : Phase[i], "f_AC(Hz)" : 31.7, "T_integration_Lock(s)" : 1.5, "B(T)" : B2[i],"T(K)" : T_real[i]})
    df.to_csv("Rawdata_T_" + str('%.0f'%(T_real[i]*10)) + ".csv", index=False)
#%% Plot dIdV T-Batch SC
#########################################
n = 8
c_buffer = 1.15
cmap = plt.cm.gist_heat
T_real_colors = (T_real[:n]-T_real[0])/(c_buffer*T_real[n-1]-T_real[0])
colors=cmap(T_real_colors)
plt.rcParams['axes.prop_cycle'] = plt.cycler(color = colors) 
plt.rcParams['figure.figsize'] = (15,15)
for run in range(n):
    
    #run = 9
    direction = 1
    Delta = 1.06
    RTI = 1220
    R_diff = splitsweep(Rdiff[run])[direction]
    I_DC = splitsweep(I_sample[run]*1e3)[direction]
    U_DC = splitsweep(U_sample[run]*1e3)[direction]
    #########################################
    R_int = R_diff-RTI
    U_int = U_DC-RTI*I_DC
    
    #shift peak to 0
    shift =8
    R_int = R_int[shift:]
    U_int = U_int[:-shift]
    
    G_int_planck = 1/(R_int)/((1.602*10**-19)**2/(6.626*10**-34))
    plt.plot(U_int,G_int_planck-5*run,label = 'T='+str('%.2f'%T_real[run])+'K')
    #plt.axvline(0,color ='black')
    #plt.axvline(Delta,color ='black')
    #plt.axvline(-Delta,color ='black')
    #plt.plot([],[],label = 'RTI = ' + str('%.1f'%RTI) + 'Ohm')
    
    
plt.title(str(IDs[0]) + '-' + str(IDs[-1]) + '[' + str(direction) + '] ' + 'Water-5' + ' RTI=' + str(RTI) +'$\Omega$'+' Shift=' + str(shift))
plt.xlabel('$E$(meV)')
plt.ylabel('$\dfrac{dI}{dV}$($e^2/h$)')
plt.xlim(-11,11)
plt.ylim(-5,135)
#sm = plt.cm.ScalarMappable(cmap = cmap, norm=plt.Normalize(vmin=T_real[0], vmax=c_buffer*T_real[n-1]))
#ax = plt.colorbar(sm)
#ax.set_label('T(K)',rotation=0)
plt.legend(fontsize=24)
#plt.savefig(str(IDs[0]) + '-' + str(IDs[-1])+ 'Rint_U'+'.png')
plt.savefig('Paper_Fig2_w' + str(IDs[0]) + '-' + str(IDs[-1]) + '_' + str(direction) + '.png')
plt.savefig('Paper_Fig2_w' + str(IDs[0]) + '-' + str(IDs[-1]) + '_' + str(direction) + '.pdf')

#%% Plot dIdV T-Batch all
#########################################
n = 8
c_buffer = 1.15
cmap = plt.cm.gist_heat
T_real_colors = (T_real[:n]-T_real[0])/(c_buffer*T_real[n-1]-T_real[0])
colors=cmap(T_real_colors)
plt.rcParams['axes.prop_cycle'] = plt.cycler(color = colors) 
plt.rcParams['figure.figsize'] = (15,15)
for run in range(n):
    
    #run = 9
    direction = 1
    Delta = 1.06
    RTI = 1220
    R_diff = splitsweep(Rdiff[run])[direction]
    I_DC = splitsweep(I_sample[run]*1e3)[direction]
    U_DC = splitsweep(U_sample[run]*1e3)[direction]
    #########################################
    R_int = R_diff-RTI
    U_int = U_DC-RTI*I_DC
    
    #shift peak to 0
    shift =8
    R_int = R_int[shift:]
    U_int = U_int[:-shift]
    G_int_planck = 1/(R_int)/((1.602*10**-19)**2/(6.626*10**-34))
    
    plt.plot(U_int,G_int_planck+ 0*run,label = 'T='+str('%.2f'%T_real[run])+'K')
    plt.axvline(0,color ='black')
    #plt.axvline(Delta,color ='black')
    #plt.axvline(-Delta,color ='black')
    #plt.plot([],[],label = 'RTI = ' + str('%.1f'%RTI) + 'Ohm')
    
    
plt.title(str(IDs[0]) + '-' + str(IDs[-1]) + '[' + str(direction) + '] ' + ' RTI=' + str(RTI) +'$\Omega$'+' Shift=' + str(shift))
plt.xlabel('$E$(meV)')
plt.ylabel('$\dfrac{dI}{dV}$($e^2/h$)')
plt.xlim(-12,12)
plt.ylim(32,135)
#plt.ylim(190,850)
sm = plt.cm.ScalarMappable(cmap = cmap, norm=plt.Normalize(vmin=T_real[0], vmax=c_buffer*T_real[n-1]))
#ax = plt.colorbar(sm)
#ax.set_label('T(K)',rotation=0)
plt.legend(fontsize=24)
#plt.savefig(str(IDs[0]) + '-' + str(IDs[-1])+ 'Rint_U'+'.png')
#plt.savefig('Paper_Fig2_all' + str(IDs[0]) + '-' + str(IDs[-1]) + '_' + str(direction) + '.png')
#plt.savefig('Paper_Fig2_all' + str(IDs[0]) + '-' + str(IDs[-1]) + '_' + str(direction) + '.pdf')
#%% Plot Supplement T Raw in 1/kOhm
#########################################
n = 8
c_buffer = 1.15
cmap = plt.cm.gist_heat
T_real_colors = (T_real[:n]-T_real[0])/(c_buffer*T_real[n-1]-T_real[0])
colors=cmap(T_real_colors)
plt.rcParams['axes.prop_cycle'] = plt.cycler(color = colors) 
plt.rcParams['figure.figsize'] = (15,15)
for run in range(n):
    
    #run = 9
    direction = 1
    Delta = 1.06
    RTI = 0
    R_diff = splitsweep(Rdiff[run])[direction]
    I_DC = splitsweep(I_sample[run]*1e3)[direction]
    U_DC = splitsweep(U_sample[run]*1e3)[direction]
    #########################################
    R_int = R_diff-RTI
    U_int = U_DC-RTI*I_DC
    
    #shift peak to 0
    shift =8
    R_int = R_int[shift:]
    U_int = U_int[:-shift]
    
    G_int =1/R_int
    
    plt.plot(U_int,G_int*1000+ 0*run,label = 'T='+str('%.2f'%T_real[run])+'K')
    #plt.axvline(0,color ='black')
    #plt.axvline(Delta,color ='black')
    #plt.axvline(-Delta,color ='black')
    #plt.plot([],[],label = 'RTI = ' + str('%.1f'%RTI) + 'Ohm')
    
    
plt.title(str(IDs[0]) + '-' + str(IDs[-1]) + '[' + str(direction) + '] ' + ' RTI=' + str(RTI) +'$\Omega$'+' Shift=' + str(shift))
plt.xlabel('$E$(meV)')
plt.ylabel('$\dfrac{dI}{dV}$$(1/k\Omega)$')
plt.xlim(-50,50)
plt.ylim(0.515,0.725)
#plt.ylim(190,850)
sm = plt.cm.ScalarMappable(cmap = cmap, norm=plt.Normalize(vmin=T_real[0], vmax=c_buffer*T_real[n-1]))
#ax = plt.colorbar(sm)
#ax.set_label('T(K)',rotation=0)
plt.legend(fontsize=24)
#plt.savefig(str(IDs[0]) + '-' + str(IDs[-1])+ 'Rint_U'+'.png')
plt.savefig('Paper_SupTraw' + str(IDs[0]) + '-' + str(IDs[-1]) + '_' + str(direction) + '.png')
plt.savefig('Paper_SupTraw' + str(IDs[0]) + '-' + str(IDs[-1]) + '_' + str(direction) + '.pdf')

#%% Peak Position Dependence

PeakL = np.array([-3.39,-3.33,-2.32,-2.03,-1.91,-1.97,-1.85,-1.70,-1.55,-1.32,-1.22,-1.08])
PeakR = np.array([3.03,3.02,2.95,2.48,2.27,1.80,1.60,1.43,1.31,1.13,1.01,0.89])
PeakB = np.array([0,0.2,0.4,0.6,0.8,1,1.2,1.4,1.6,1.8,2,2.2])

Peak = (PeakR-PeakL)/2
plt.plot(PeakB, Peak, '.')

def Linfunc(x,a,b):
    return a*x + b

popt2, pcov2 = curve_fit(Linfunc,PeakB[3:], Peak[3:])
plt.plot(PeakB, Linfunc(PeakB,popt2[0],popt2[1]),'-k', linewidth=5, label= '$U_{Peak}$= = ' + str('%.2f'%popt2[0]) + '*B+' + str('%.2f'%popt2[1]) )
plt.title('ID:' + str(IDs[0]) + '-' + str(IDs[-1]) + 'Water' + ' RTI =' + str(RTI) +'$Ohm$'+' Dir = ' + str(direction) +' Run = ' + str(run) +' Shift = ' + str(shift))
plt.xlabel('$B$(T)')
plt.ylabel('$Peakwidth$($meV$)')
plt.legend()
#plt.savefig('Paper_Fig4_Fit_' + str(IDs[0]) + '-' + str(IDs[-1]) + '_' + str(direction) + '.png')
#plt.savefig('Paper_Fig4_Fit_' + str(IDs[0]) + '-' + str(IDs[-1]) + '_' + str(direction) + '.pdf')
#plt.savefig(str(IDs[0]) + '-' + str(IDs[-1])+ 'PeakB'+'.png')